 /*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <darktempler@gmail.com> wrote this file. As long as you retain this notice you
 * can do whatever you want with my code. If we meet some day, and you think
 * this code is worth it, you can buy me a beer in return - Matt Labrum (-dt-)
 * ----------------------------------------------------------------------------
 */
 
 /* 
	$LastChangedBy: dt $ 
	$LastChangedDate: 2007-03-03 03:04:53 -0800 (Sat, 03 Mar 2007) $
	$LastChangedRevision: 292 $
	$HeadURL: http://svn.thedt.net/scripts/plusscripts/musicNowplaying/main.js $
*/      

var prefs;
var playersClasses = [];
var globalPlayers = {};
var WM_USER = 1024;
var TB_ENABLEBUTTON = WM_USER + 1;
var trans;
var globalScope = this;
var GETAVATAR = false;
var signedin = false;

function OnEvent_SigninReady(email) {
  prefs = new PrefStore(email);
	if(prefs.get('FirstTime') == -1){
		SetFirstTimeSettings()
	}else{
		if(typeof(Messenger.MyEmail)!='unknown'){
			UpdateClass.StartParse();
		}  
	}
	
	var lang = prefs.get("language");
	  
	if(lang == -1 || lang == "Auto Select"){
 
		switch(MsgPlus.UILangCode){   
			case "es" : plusLang = "Espanol"; break;
			case "en" : plusLang = "English"; break;
			case "nl" : plusLang = "Nederlands"; break;
			case "it" : plusLang = "Italian"; break;
			default : plusLang = "English"; break;
		}
		lang = plusLang;

		prefs.set("language", "Auto Select");
		prefs.save();
	}
	
	trans = new Translation(lang);
	
	//	<OleFiles> kept crashing so heh we do it the hard way =p
	var wmpInstalledDll = prefs.get('wmpdone');
	if(wmpInstalledDll == -1 || !wmpInstalledDll){
		register_wmp();
		prefs.set('wmpdone', 1);
		prefs.save();
	}
	
	if(prefs.get("default/player") == -1){
		prefs.set("default/player", "Winamp");
		prefs.save();
	}

	 triggerEvent('initialize');

	var xxx = prefs.get("dp/enabled");
	if(xxx && xxx != -1){
		Start_dp();
	}
	
	//start psm or stop it
	var xxx = prefs.get("PSM/enabled");
	if(xxx && xxx != -1){
		Start_psm();
	}

	var globalEnabled = prefs.get("hotkeys/global/enable");
	if(globalEnabled && globalEnabled != -1){
		var globalHotkey = prefs.get("hotkeys/global/key");
		if(globalHotkey != 0 && globalHotkey != -1){
			registerGlobalHotkey(globalHotkey, sendGlobalNP);
		}
	}
	//UpdateClass.StartParse();
	signedin = true;
}
 
function OnEvent_Initialize(MessengerStart){ 

	//uninstalls the old players
	var fso = new ActiveXObject('Scripting.FileSystemObject');
	var OldFiles = [
		"iTunesClass.js",
		"WinampClass.js",
		"wmpClass.js",
		"jetAudioClass.js",
		"players\\MusicMonkey.player.js"
	];
	for(file in OldFiles){
		var name = MsgPlus.ScriptFilesPath + "\\" + OldFiles[file];
		if(fso.FileExists(name)){ fso.GetFile(name).Delete(true);}
	}
	
	//load the players into the main scope.
	var x;
	for(var enume = new Enumerator(fso.GetFolder(MsgPlus.ScriptFilesPath + "\\players").Files);!enume.atEnd();enume.moveNext()){
		if(x = new String(enume.item()).match(/([^[\\]*?)\.player\.js$/)){
			playersClasses.push(x[1]);
			
			try{
				eval(fso.GetFile(enume.item()).OpenAsTextStream(1, 0).ReadAll());
				globalScope[x[1]] = eval(x[1]);
			}catch(e){
					Debug.Trace("ERROR loading player " + x[1] + ": \nType: " + e['name'] + "\nMessage: " + e['message'] + "\nNumber: " + x['number'] + "\nDescription: " + x['description']);
			}
		}  
	} 
	
	prefs = new PrefStore(Messenger.MyEmail);
	if(prefs.get('FirstTime') == -1){
		SetFirstTimeSettings()
	}else{
		if(typeof(Messenger.MyEmail)!='unknown'){
			UpdateClass.StartParse();
		}  
	}
	
	var lang = prefs.get("language");
	  
	if(lang == -1 || lang == "Auto Select"){
 
		switch(MsgPlus.UILangCode){   
			case "es" : plusLang = "Espanol"; break;
			case "en" : plusLang = "English"; break;
			case "nl" : plusLang = "Nederlands"; break;
			case "it" : plusLang = "Italian"; break;
			default : plusLang = "English"; break;
		}
		lang = plusLang;

		prefs.set("language", "Auto Select");
		prefs.save();
	}
	
	trans = new Translation(lang);
	
	//	<OleFiles> kept crashing so heh we do it the hard way =p
	var wmpInstalledDll = prefs.get('wmpdone');
	if(wmpInstalledDll == -1 || !wmpInstalledDll){
		register_wmp();
		prefs.set('wmpdone', 1);
		prefs.save();
	}
	
	if(prefs.get("default/player") == -1){
		prefs.set("default/player", "Winamp");
		prefs.save();
	}

	 triggerEvent('initialize');

	var xxx = prefs.get("dp/enabled");
	if(xxx && xxx != -1){
		Start_dp();
	}
	
	//start psm or stop it
	var xxx = prefs.get("PSM/enabled");
	if(xxx && xxx != -1){
		Start_psm();
	}

	var globalEnabled = prefs.get("hotkeys/global/enable");
	if(globalEnabled && globalEnabled != -1){
		var globalHotkey = prefs.get("hotkeys/global/key");
		if(globalHotkey != 0 && globalHotkey != -1){
			registerGlobalHotkey(globalHotkey, sendGlobalNP);
		}
	}
}

function OnEvent_Signout(Email) {
  signedin = false;
}

function OnEvent_Uninitialize(){
	destoryAllGlobalPlayers();
	unRegisterAllGlobalHotkeys();
	triggerEvent('unitinitalize');
}

function OnEvent_DownloadFileComplete(url, outfile, sucess){
	triggerEvent("DownloadFileComplete", url, outfile, sucess);
	triggerEvent("DownloadFileComplete_" + url, url, outfile, sucess);
}

/*

	use sendInput

*/

function sendGlobalNP(){
	
	var player = getPlayer();
	if(player){
		var test = parseSongFormat(player, "Unknown", prefs.get("hotkeys/global/format"));
		sendKeysA(test);
		//sendKeysW(test);
	}
	
}

function get_error(error){
   var msg = Interop.Allocate(1024);
    Interop.Call("Kernel32", "FormatMessageW", 0x1000, 0, error, 0, msg, 1024, 0);
    return msg.ReadString(0);
}

/*
function Start_skype(){
	addEventListener(['songChange', 'songStatusChanged' ], "_main_skype", function(playerName, player, status){
		var oSkype = new ActiveXObject("Skype4COM.Skype");
	
	});

	addEventListener('playerClosed', "_main_skype", function(name){
		//set to false
	});
	
	requestSongChange();
}

function Stop_skype(){
	//stop skype playing
	removeEventListener(['songChange', 'songStatusChanged', "playerClosed"], "_main_skype");
	RequestRemoveSongChange();
}
*/

function Start_psm(){
	
	addEventListener(['songChange', 'songStatusChanged' ], "_main_psm", function(playerName, player, status){
		if(typeof(status) != "undefined" && status == 0){
			setNowPlaying(false);
		}else{
			var format = prefs.get("PSM/format");
			format = (format == -1) ?  "{artist} - {title} {status}" : format;
			setNowPlaying(true, "Music", parseSongFormat(player, playerName, format));
		}
	});

	addEventListener('playerClosed', "_main_psm", function(name){
		setNowPlaying(false);
	});
	requestSongChange();
	
}

function Stop_psm(){
	setNowPlaying(false);
	removeEventListener(['songChange', 'songStatusChanged', "playerClosed"], "_main_psm");
	RequestRemoveSongChange();
	
}

var DP_ACTIVE = false;
function Start_dp(){
	
	DP_ACTIVE = true;
	addEventListener('unitinitalize', "_main_album", function(){
		Stop_dp();
	})
	addEventListener(['songChange', 'songStatusChanged' ], "_main_album", function(playerName, player, status){
		var old = prefs.get("album/restore");
		if(old == -1 || !GETAVATAR){
			prefs.set("album/restore", Messenger.MyDisplayPicture);
			prefs.save();
			old = Messenger.MyDisplayPicture;
			GETAVATAR = true;
		}
		
		if(typeof(status) != "undefined" && status == 0){
			try{ Messenger.MyDisplayPicture = old;}catch(e){}
			GETAVATAR = false;
		}else{
			var album = player.getAlbum();
			var artist = player.CurrentTrack().Artist;
			var file = player.CurrentFilename();
			if(album == ""){
					var covdefault = prefs.get("dp/default");
					if(covdefault == -1)covdefault = MsgPlus.ScriptFilesPath + "\\Images\\NoCover.png";
					Messenger.MyDisplayPicture = covdefault;
			}else{
				getAlbum(artist, album, function(path){
					
					if(path && fso.FileExists(path)){
						try{Messenger.MyDisplayPicture = path;}catch(e){};
						triggerEvent("AlbumArt", path);
					}else{
						var covdefault = prefs.get("dp/default");
						if(covdefault == -1)covdefault = MsgPlus.ScriptFilesPath + "\\Images\\NoCover.png";
						Messenger.MyDisplayPicture = covdefault;
						path = covdefault;
					}
				}, file);
			}
		
		}
	}); 
	requestSongChange();
}

function Stop_dp(){

	removeEventListener(['songChange', 'songStatusChanged' ], "_main_album");
	RequestRemoveSongChange();
	if(DP_ACTIVE){
		var old = prefs.get("album/restore");
		if(old != -1){
			try{ Messenger.MyDisplayPicture = old;}catch(e){}
		}
	}

}

function getGlobalPlayer(name){
		var player;
		
		if(typeof(globalPlayers[name]) == "undefined"){
			try{
				eval("player = new " + name);
				globalPlayers[name] = player;
				return player;
			}catch(e){
				Debug.Trace(e.message);
				throw "player not found";
			}
		}else{
			return globalPlayers[name];
		}
}

function destoryGlobalPlayer(name){
	if(typeof(globalPlayers[name]) != "undefined"){
		
		globalPlayers[name].__destruct();
		delete globalPlayers[name];
	}
}

function destoryAllGlobalPlayers(){
	for(player in globalPlayers){
		destoryGlobalPlayer(player);
	}
}

//made into a function so people can type /script register_wmp
function register_wmp(){
	new ActiveXObject("wscript.shell").run('regsvr32 -s "' + MsgPlus.ScriptFilesPath +'\\dlls\\wmp9.dll"');
}

function OnEvent_Signin(){
	UpdateClass.StartParse();
}

function OnGetScriptCommands(){
	var commands = [
		{"Name" : "play", "Description" : "Plays current song", "Parameters" : ""},
		{"Name" : "pause", "Description" : "Pauses current song", "Parameters" : ""},
		{"Name" : "next", "Description" : "Skips to next song", "Parameters" : ""},
		{"Name" : "prev", "Description" : "Skips to the previous song", "Parameters" : ""},
		{"Name" : "stop", "Description" : "sends the current song", "Parameters" : ""},
		{"Name" : "sendsong", "Description" : "Stops the current song", "Parameters" : ""},
		{"Name" : "lyrics", "Description" : "open the lyrics window", "Parameters" : ""}
	];

	triggerEvent("OnGetScriptCommands", commands);
	var str = "<Command><Name>%s</Name><Description>%s</Description><Parameters>%s</Parameters></Command>";
	var ret = "<ScriptCommands>";
	
	for(x in commands){
		ret += sprintf(str, commands[x].Name, commands[x].Description, commands[x].Parameters);
	}
	
	return ret + "</ScriptCommands>"
}

function OnEvent_ChatWndSendMessage(wnd,message){
	if(message.match(/\(!WAT\)/gi)){
		return message.replace(/\(!WAT\)/gi,sendCurrentSong('Winamp',prefs.get('wat')));
	}else if(message.match(/\(!IWAT\)/gi)){
		return message.replace(/\(!IWAT\)/gi,sendCurrentSong('iTunes',prefs.get('wat')));
	}else if(message.match(/\(!WWAT\)/gi)){
		return message.replace(/\(!WWAT\)/gi,sendCurrentSong('WMP',prefs.get('wat')));
	}else if(message.match(/\(!JWAT\)/gi)){
		return message.replace(/\(!JWAT\)/gi,sendCurrentSong('jetAudio',prefs.get('wat')));
	}else if(message.match(/\(!MWAT\)/gi)){
		return message.replace(/\(!MWAT\)/gi,sendCurrentSong('MusicMonkey',prefs.get('wat')));
	}
	
	ob = {"text" : false}
	triggerEvent("OnEvent_ChatWndSendMessage", wnd, message, ob);
	if(ob.text){
		return ob.text;
	} 
	
	switch(message){
		case "/pause" : getPlayer().Pause();return '';
		case "/play" : getPlayer().Play();return '';
		case "/stop" : getPlayer().Stop();return '';
		case "/next" : getPlayer().Next();return '';
		case "/prev" : getPlayer().Prev();return '';
		case "/sendsong" : transferSong(wnd);return '';
		case "/lyrics" : openLyricWnd();return'';
	}
	
}
 
function OnEvent_ChatWndReceiveMessage(wnd, origin, message){

	if(origin != Messenger.MyName){
		var remoteSong = prefs.get('remote/song');
		var remoteSend = prefs.get('remote/send');
		var remoteShare = prefs.get('remote/shared');
		
		remoteSong = (remoteSong == -1 ) ?  "!np" : remoteSong;
		remoteSend= (remoteSend == -1 ) ?  "!sendsong" : remoteSend;
		remoteShare = (remoteShare == -1 ) ?  "!addtoshared" : remoteShare;
	
		if(remoteSong != "" && prefs.get('remote/enabled/song')){
			if(message.match(new RegExp("^" + remoteSong.preg_quote() + "$","i"))){
				wnd.SendMessage(sendCurrentSong());
			}
		}
		if(remoteSend != "" && prefs.get('remote/enabled/send')){
			if(message.match(new RegExp("^" + remoteSend.preg_quote() + "$","i"))){
				
				if(!transferSong(wnd,1)){
					wnd.SendMessage(prefs.get('notrunning').replace('{player}',"unknown"));
				}
				
			}
		}
		
		if(remoteShare != "" && prefs.get('remote/enabled/shared')){
			if(message.match(new RegExp("^" + remoteShare.preg_quote() + "$","i"))){
				copyToShareingFolder(wnd.Contacts, wnd);
			}
		}
		
	}
}

function OnGetScriptMenu(location){
	var menu = '';
	menu += "<ScriptMenu>"
	var players = playersClasses;
	var menuTrans = trans.GetMenu("Main");
	
	if(location == 2){
		
		for(x in players){
			menu += "		<MenuEntry Id=\"sendSongTitle_" +players[x] +"\">" + sprintf(menuTrans.GetString("sendSong"), players[x]) + "</MenuEntry>"
		}
		
		menu += "		<Separator/>";
		menu += "		<MenuEntry Id=\"lyrics\">" + menuTrans.GetString("openLyrics") + "</MenuEntry>"
		menu += "		<MenuEntry Id=\"sendSong\">" + menuTrans.GetString("tranfer") + "</MenuEntry>"
		menu += "		<MenuEntry Id=\"sendToShareing\">" + menuTrans.GetString("share") + "</MenuEntry>"
		menu += "		<Separator/>"
		menu += "		<MenuEntry Id=\"configure\">" + menuTrans.GetString("configure") + "</MenuEntry>"
		menu += "		<MenuEntry Id=\"about\">" + menuTrans.GetString("about") + "</MenuEntry>"
	}else{
		menu += "		<MenuEntry Id=\"configure\">" + menuTrans.GetString("configure") + "</MenuEntry>"
		menu += "		<MenuEntry Id=\"about\">" + menuTrans.GetString("about") + "</MenuEntry>"
		menu += "		<Separator/>"
		menu += "		<MenuEntry Id=\"lyrics\">" + menuTrans.GetString("openLyrics") + "</MenuEntry>"
	}
	menu += "	</ScriptMenu>"

	return menu;
}

function OnEvent_MenuClicked(id,location,wnd){
	var x;
	switch(id){
		case "configure" : openConfig();break;
		case "about" : openConfig('About'); break;
		case "lyrics" : openLyricWnd();break;
		case "sendSong" : transferSong(wnd);break
		case "sendToShareing" : copyToShareingFolder(wnd.Contacts);break;
		default : if(x = id.match(/^sendSongTitle_(.*?)$/)){ wnd.SendMessage(sendCurrentSong(x[1]))};
	}
}

function copyToShareingFolder(contacts, chat){
	
	var dir = getSpecialDir(0x001c) + "\\Microsoft\\Messenger\\" + Messenger.MyEmail + "\\Sharing Folders\\";

	var fso = new ActiveXObject('Scripting.FileSystemObject');
	var folder;
	var cur;
	var song;
	var player = getPlayer();
	var xxx = false;
	
	var translation = trans.GetWindow('random').GetStringBundle("sharedfoldererror");
	
	var num = 0;
	for(var enume = new Enumerator(contacts);!enume.atEnd();enume.moveNext()){
		num++;
	}
	
	if(num != 1){
		if(typeof(chat) != "undefined"){
			chat.SendMessage(translation.GetString('group'));
		}else{
			Interop.Call("User32", "MessageBoxW", 0, translation.GetString('group'), translation.GetString('alertTitle'), 0);
		}
		return;
	}
	
	if(player){
		var songPath = player.CurrentFilename();
		if(fso.FileExists(songPath)){
			for(var enume = new Enumerator(contacts);!enume.atEnd();enume.moveNext()){
				cur = enume.item();
				folder = dir + cur.Email;
				if(fso.FolderExists(folder)){
					song = songPath.match(/\\([^\\]*)$/)[1]
					try{
						fso.CopyFile(songPath, folder + "\\" + song);
						xxx = true;
					}
					catch(E){
						Debug.Trace("Error: " + E.message);
					}
				}else{
					if(typeof(chat) != "undefined"){
						chat.SendMessage(sprintf(translation.GetString('notfound'), cur.Email));
					}else{
						Interop.Call("User32", "MessageBoxW", 0, sprintf(translation.GetString('notfound'), cur.Email), translation.GetString('alertTitle'), 0);
					}
				}
			}
			if(xxx){
				
				MsgPlus.DisplayToastContact(translation.GetString('addedTitle'), translation.GetString('added'), song);
				if(typeof(chat) != "undefined")chat.SendMessage(translation.GetString('addedTitle'));
			}
		}else{
			if(typeof(chat) != "undefined"){
				chat.SendMessage(sprintf(translation.GetString('unabletogetpath'), songPath));
			}else{
				Interop.Call("User32", "MessageBoxW", 0, sprintf(translation.GetString('unabletogetpath'), songPath), translation.GetString('alertTitle'), 0);
			}
		}
	}else{
	
		if(typeof(chat) != "undefined"){
			chat.SendMessage(translation.GetString('notsupported'));
		}else{
			Interop.Call("User32", "MessageBoxW", 0,translation.GetString('notsupported') , translation.GetString('alertTitle'), 0);
		}
	}

}

function getSpecialDir( CSIDL){
	var szSendToPath = Interop.Allocate((255 *2) +2);
	Interop.Call("Shell32", "SHGetSpecialFolderPathW", 0, szSendToPath,  CSIDL, 0);
	return szSendToPath.ReadString(0);
}

//returns the first open player
function getPlayer(){
	var player;
	for(var i=0;i<playersClasses.length;i++){
		try{
			eval("player = new " + playersClasses[i]);
		}catch(e){
			Debug.Trace(e.Message);
			continue;
		}
	
		if(player.open){return player;}
	}
	return false;
}

function sendCurrentSong(playername,format){

	//get player
	var player;
	if(typeof(playername) != "undefined"){
		try{
			eval("player = new " + playername);
		}catch(e){
			Debug.Trace(e.Message);
			return playername + " isn't installed";
		}
	
	}else{
		player = getPlayer();
	}
	if(!player.open){
		return prefs.get('notrunning').replace('{player}',playername);
	}
	
	var str = parseSongFormat(player, playername, format);
	player.__destruct();

	return str;
}

function parseSongFormat(player, playername, format){
	if(typeof(settings) == 'undefined'){
		if(typeof(format) == 'undefined') var format = prefs.get('format');
		var status = prefs.getAsArray('status');
		var bar = prefs.getAsArray('bar');
	}
 
	var Pstatus = player.Status();
	
	var sText, statusText;
	if(Pstatus == 1){
		statusText = "playing";
		sText = status.playing;
	}else if(Pstatus == 3){
		statusText = "paused";
		sText = status.paused;
	}else{
		statusText = "stopped";
		sText = status.stopped;
	}
	format = format.replace(/\{status\}/g,sText);
	format = format.replace('{player}',playername);

	format = format.replace(/\{elapsed\}/g,player.SongPosition(true));
	//volume
	format = format.replace(/\{listpos\}/g,player.PlaylistPosition());
	format = format.replace(/\{listlength\}/g,player.PlaylistLength());
	
	var title = player.CurrentTrack();

	format = format.replace(/\{artist\}/g,title.Artist);
	
	var album = player.getAlbum();
		
	format = format.replace(/\{title\}/g,title.Title);
	
	format = format.replace(/\{album\}/g, album);
	
	format = format.replace(/\{bitrate\}/g,player.getBitrate());
	format = format.replace(/\{srate\}/g,player.getSampleRate());
	
	var filename = player.CurrentFilename();
	format = format.replace(/\{filename\}/g, filename.replace(/^(.*)\\([^\\]*)$/,'$2'));
	
	var fileextentionparts = filename.split(".");
	if(fileextentionparts.length > 0){
		var ext = fileextentionparts[fileextentionparts.length-1];
	}else{
		ext = "";
	}
	
	format = format.replace(/\{ext\}/g, ext);
	
	var length = player.SongLength(false);
	var done = player.SongPosition(false)
	
	if(slength == '00:0-1' || done > length){
		format = format.replace(/\{length\}/g,  'Streaming');	
		var stream = true;
	}else{
		var slength = player.SongLength(true);
		format = format.replace(/\{length\}/g, slength);
		var stream = false;
	}
	
	if(length != -1 && length != 0 && length > done){
		format = format.replace(/\{bar\}/, getProgressBar(bar.multiplier,bar.separator,bar.filler,bar.wrapper, done,length));
	}else{
		format = format.replace(/\{bar\}/,'');
	}
	
	//- [if_*=paused] show this[/if_*]
//	where * is the tag, like artist, title, album, status
	var ifTagsCond = {
		"artist" : title.Artist,
		"album" : album,
		"title" : title.Title,
		"status" : statusText,
		"player" : playername,
		"ext" : ext
	}
	
	var regexp;
	
	for(tag in ifTagsCond){
		regexp = new RegExp(sprintf("\\[if_%s(=|!=)(.*?)\\](.*?)\\[\\/if_%s\\]", tag, tag), "gi");
		format.replace(regexp, function(all, type, compare, data){
			if(type == "="){
				if(ifTagsCond[tag].toLowerCase() == compare.toLowerCase()){
					format = format.replace(new RegExp(sprintf("\\[if_%s=%s\\]%s\\[\\/if_%s\\]", tag, compare, data.preg_quote(), tag), "gi"), data);
				}else{
					format = format.replace(all, "");
				}
			}else if(type == "!="){
				if(ifTagsCond[tag].toLowerCase() != compare.toLowerCase()){
					format = format.replace(new RegExp(sprintf("\\[if_%s!=%s\\]%s\\[\\/if_%s\\]", tag, compare, data.preg_quote(), tag), "gi"), data);
				}else{
					format = format.replace(all, "");
				}
			}
		});
	}
	
	// /\[if_artist\](.*?)\[\/if_artist\]/gi
	var ifTags = {
		"artist" : title.Artist,
		"album" : album,
		"title" : title.Title,
		"stream" : stream
	}
	
	var regexp;
	
	for(tag in ifTags){
		regexp = new RegExp(sprintf("\\[if_%s\\](.*?)\\[\\/if_%s\\]", tag, tag), "gi");
		if(ifTags[tag] == "" || ifTags[tag] == " "|| !ifTags[tag] ){
			format = format.replace(regexp, "");
		}else{
			format = format.replace(regexp, "$1");
		}
		
		regexp = new RegExp(sprintf("\\[!if_%s\\](.*?)\\[\\/!if_%s\\]", tag, tag), "gi");
		if(ifTags[tag] == "" || ifTags[tag] == " "|| !ifTags[tag] ){
			format = format.replace(regexp, "$1");
		}else{
			format = format.replace(regexp, "");
		}
	}

	format = format.replace(/\\n/g,"\n");
	return format;

}

//function by segosa
function getProgressBar(mult, sep, fill, wrapper , elapsed , total){
        if (typeof(mult) == 'undefined') mult = 10;
        if (typeof(sep) == 'undefined') sep = "|";
        if (typeof(fill) == 'undefined') fill = "--";
        if (typeof(wrapper) == 'undefined') wrapper = "[]";

        var e = Math.round((elapsed / total) * mult);
        var t = Math.round((1 - (elapsed / total)) * mult);
        return rptChar(fill.charAt(0), e) + sep + rptChar(fill.charAt(1), t);
}

function rptChar(chr, num){
        var str = "";
        while (num-- > 0)
            str += chr;
        return str;
}

function transferSong(wnd,noAlert){
	//get player
	var player = getPlayer();
	
	if(!player && typeof(noAlert) == "undefined"){
		alert(wnd,"Script Error",prefs.get('notrunning').replace('{player}',playername));
		return;
	}
	
	if(!player && typeof(noAlert) != "undefined"){
		return false;
	}

	wnd.SendFile(player.CurrentFilename());
	
	player.__destruct();
	return true;
}

function alert(wnd,title,message){
	Interop.Call("User32", "MessageBoxW", wnd.Handle, message, title, 0);
}

function SetFirstTimeSettings(){
	prefs.set('format','[b]NP[/b]: [if_artist]{artist} - [/if_artist]{title} [{elapsed}/{length}] [{bar}] {status}');
	prefs.set('status/paused','(Paused)');
	prefs.set('status/stopped','(Stopped)');
	prefs.set('status/playing',' ');
	
	prefs.set('bar/multiplier','10');
	prefs.set('bar/separator','|');
	prefs.set('bar/filler','--');

	prefs.set('notrunning','{player} isnt running');
	prefs.set('wat','[if_artist]{artist} - [/if_artist]{title}');

	prefs.set('remote/song', "!np");
	prefs.set('remote/send', "!sendsong");

	prefs.set('FirstTime',1);
	prefs.save();
}

//random api stuff by -dt-

/*
Function by -dt- (Matt Labrum) (Converted from http://forums.fanatic.net.nz/index.php?showtopic=11311&st=0# )

Void setNowPlaying( boolean enabled, [String type [, String format [, String title [, String artist [, String album [, String contentID ]]]]]] );

if enabled is true the now playing will show, if its false then the personal message will show.
type is the type of image you want to display. Either Music, Office or Games.
format is the format of the song eg {0} by {1} which would show title by artist.
format can also be a message eg "moo goes the cow"

Examples:

setNowPlaying(true, "Music", "{0} - {1}", "dt", "dt's band", "dt's album");

or setting it to a Game icon and displaying a message

setNowPlaying(true, "Games", "yay playing warcraft");

or set it to the office icon 
Playing(true, "Office", "yay using word :P");
setNow

and turning it off
setNowPlaying(false);

*/

function setNowPlaying(enabled, type, format, title, artist, album, contentID){
	if(typeof(type) == "undefined")type = "Music";
	if(typeof(format) == "undefined")format = "";
	if(typeof(title) == "undefined")title = "";
	if(typeof(artist) == "undefined")artist = "";
	if(typeof(album) == "undefined")album = "";
	if(typeof(contentID) == "undefined")contentID = "";
	enabled = Math.abs(enabled);
	
	var WM_COPYDATA = 0x4A;
	
	//reference 
	var song = Interop.Allocate(512);
	
	//change the Music thing to Games or Office or 
	song.WriteString(0, "\\0" + type + "\\0" + enabled + "\\0" + format +"\\0" + title +"\\0" + artist + "\\0" + album + "\\0" + contentID + "\\0");
	
	//write our copyDataStruct Structure
	var copyDataStruct = Interop.Allocate(12);
	copyDataStruct.WriteDWORD(0, 0x547); //dwData
	copyDataStruct.WriteDWORD(4, song.Size); //cbData
	copyDataStruct.WriteDWORD(8, song.DataPtr);  //lpData
	
	//Send it to all open messengers
	var hMSGRUI = 0;
	do{
		hMSGRUI = Interop.Call("User32", "FindWindowExW", 0, hMSGRUI, "MsnMsgrUIManager", 0);
		if(hMSGRUI > 0){
			Interop.Call("User32", "SendMessageW", hMSGRUI, WM_COPYDATA, 0, copyDataStruct);	
		}
	}while(hMSGRUI != 0);

}

function MAKELPARAM(wLow , wHigh){
	return MAKELONG(wLow,wHigh);
}

function MAKELONG(wLow,wHigh){
	return LOWORD(wLow) | (0x10000 * LOWORD(wHigh));
}

function LOWORD(dwValue){
	var mem = Interop.Allocate(16);
	var xx = Interop.Allocate(16);
	mem.WriteWord(0,dwValue);
	Interop.Call('Kernel32','RtlMoveMemory',xx, mem,2);
	return xx.ReadWord(0);
}

/*
* ---------------------------
* Void ListViewAddRow (PlusWindow wnd , String id, Array row)
* adds a row to a listView
* ----------------------------
*/
function ListViewAddRow(window,id,row){
	var pos = window.LstView_AddItem(id,row[0]);
	
	for(var i=1;i<row.length;i++){
		window.LstView_SetItemText(id,pos,i,row[i]);
	}
}

/*
* ---------------------------
* Void clearListView (PlusWindow wnd , String id)
* clears all items from a listview
* ----------------------------
*/
function clearListView(wnd,id){
	var xxx = parseInt(wnd.LstView_GetCount(id));
	for(var i=0;i<xxx;i++){
		wnd.LstView_RemoveItem(id,0);
	}

}
